﻿<Graph ClassName="ChangeWHProc" Source="#CDATA" IsNew="True" FileType="NewGraph">
    <CDATA name="Source"><![CDATA[using System;
using System.Collections;
using System.Collections.Generic;
using PX.Data;
using PX.Objects.SO;
namespace Dispatch
{
	public class ChangeWHProc : PXGraph<ChangeWHProc>
	{
		public PXCancel<SOLine> Cancel;
		public PXFilter<SOFilter> FilterSO;
        public PXProcessingJoin<SOLine,
            LeftJoin<SOOrder, On<SOOrder.orderNbr, Equal<SOLine.orderNbr>, And<SOOrder.orderType, Equal<SOLine.orderType>>>,
            LeftJoin<SOShipLine, On<SOShipLine.origOrderNbr, Equal<SOLine.orderNbr>, And<SOShipLine.origOrderType, Equal<SOLine.orderType>, And<SOShipLine.origLineNbr, Equal<SOLine.lineNbr>>>>,
            LeftJoin<SOShipment, On<SOShipment.shipmentType, Equal<SOShipLine.shipmentType>,And<SOShipment.shipmentNbr,Equal<SOShipLine.shipmentNbr>>>>>>> SOTransactions;


        #region Dataview Delegate

        protected IEnumerable sOTransactions()
        {
            var filter = FilterSO.Current;
            PXSelectBase<SOLine> query = new PXSelectJoin<SOLine,
            LeftJoin<SOOrder, On<SOOrder.orderNbr, Equal<SOLine.orderNbr>, And<SOOrder.orderType, Equal<SOLine.orderType>>>,
            LeftJoin<SOShipLine, On<SOShipLine.origOrderNbr, Equal<SOLine.orderNbr>, And<SOShipLine.origOrderType, Equal<SOLine.orderType>, And<SOShipLine.origLineNbr, Equal<SOLine.lineNbr>>>>,
            LeftJoin<SOShipment, On<SOShipment.shipmentType, Equal<SOShipLine.shipmentType>, And<SOShipment.shipmentNbr, Equal<SOShipLine.shipmentNbr>>>>>>,
            Where<SOShipment.operation, Equal<SOShipmentType.issue>, And<SOShipment.shipmentNbr, IsNotNull,And<SOOrder.orderNbr,IsNotNull>>>>(this);
            query.WhereAnd<Where<SOShipment.status, NotEqual<SOShipmentStatus.invoiced>>>();
            query.WhereAnd<Where<SOShipment.status, NotEqual<SOShipmentStatus.completed>>>();
            if(filter.ShipmentNbr != null) { query.WhereAnd<Where<SOShipment.shipmentNbr, Equal<Current<SOFilter.shipmentNbr>>>>(); }
            if(filter.SONumber != null) { query.WhereAnd<Where<SOOrder.orderNbr,Equal<Current<SOFilter.sONumber>>>>(); }
            
            foreach(PXResult<SOLine,SOOrder,SOShipLine,SOShipment> res in query.Select())
            {
                SOOrder ord = res;
                if(ord.OrderNbr != null)
                {
                    yield return res;
                }
            }
        }

        #endregion
        #region UnboundTable

        public class SOFilter : IBqlTable
        {
			public abstract class sONumber : IBqlField { }
			[PXString(15,IsUnicode = true)]
			[PXUIField(DisplayName = "SO Number")]
			[PXSelector(typeof(Search<SOOrder.orderNbr>),typeof(SOOrder.orderType),typeof(SOOrder.orderNbr),typeof(SOOrder.customerID),typeof(SOOrder.customerID_Customer_acctName))]
			public virtual string SONumber { get; set; }

			public abstract class shipmentNbr : IBqlField { }
			[PXString(15, IsUnicode = true)]
			[PXUIField(DisplayName = "Shipment Number")]
			[PXSelector(typeof(Search<SOShipment.shipmentNbr>),typeof(SOShipment.shipmentType),typeof(SOShipment.shipmentNbr))]
			public virtual string ShipmentNbr { get; set; }
        }

        #endregion

        #region Constructor

		public ChangeWHProc()
        {
            ChangeWHProc graph = null;
            SOTransactions.SetSelected<SOLineExt.usrSelected>();
            SOTransactions.SetProcessDelegate((List<SOLine> list) =>
            {
                graph = PXGraph.CreateInstance<ChangeWHProc>();
                ChangeSOWH(list,graph);
            });
        }

        #endregion

        #region EventHandlers

        protected void SOLine_RowSelected(PXCache sender, PXRowSelectedEventArgs e)
        {
            var row = e.Row as SOLine;
            if (row == null) return;
            SOLineExt rowExt = SOTransactions.Cache.GetExtension<SOLineExt>(row);
            PXUIFieldAttribute.SetEnabled(sender, row, false);
            PXUIFieldAttribute.SetEnabled<SOLineExt.usrSelected>(sender, row, true);
            PXUIFieldAttribute.SetEnabled<SOLine.siteID>(sender, row, rowExt.UsrSelected == true);
        }

        #endregion

        #region Method

        public static void ChangeSOWH(List<SOLine> lines, ChangeWHProc graph)
        {
            SOOrderEntry soGraph = PXGraph.CreateInstance<SOOrderEntry>();
            foreach(SOLine soLine in lines)
            {
                soGraph.Clear();
                SOLineExt soLineExt = graph.SOTransactions.Cache.GetExtension<SOLineExt>(soLine);
                if (soLineExt.UsrSelected == true)
                {
                    soGraph.Document.Current = soGraph.Document.Search<SOOrder.orderNbr>(soLine.OrderNbr,soLine.OrderType);
                    SOLine soLineSel = PXSelect<SOLine,Where<SOLine.orderNbr,Equal<Required<SOLine.orderNbr>>,
                        And<SOLine.orderType,Equal<Required<SOLine.orderType>>,And<SOLine.lineNbr,Equal<Required<SOLine.lineNbr>>>>>>.Select(graph,soLine.OrderNbr,soLine.OrderType,soLine.LineNbr);
                    soGraph.Transactions.Cache.SetValueExt<SOLine.siteID>(soLineSel,soLine.SiteID);
                    soGraph.Transactions.Update(soLineSel);
                    soGraph.Persist();
                }
            }
        }

        #endregion

    }
}]]></CDATA>
</Graph>